Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/FrmSelectRegField.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/FrmSelectRegField.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/FrmSelectRegField.cs	(revision 51)
@@ -0,0 +1,525 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+using System.Collections;
+
+using log4net;
+using log4net.Appender;
+using log4net.Repository.Hierarchy;
+
+using ProcessManagement.Common;
+using ProcessManagement.DB.IOAccess;
+using ProcessManagement.DataModel;
+using ProcessManagement.DB.Core;
+using ProcessManagement.Forms.CustomControls;
+using ProcessManagement.Forms.ControlsAction;
+using ProcessManagement.Forms.SubForms;
+
+
+namespace ProcessManagement.Forms.DataEntry
+{
+    public partial class FrmSelectRegField : Form
+    {
+        //log4netログを使用する
+        private static readonly log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
+
+        // 列インデックスenum ※■は非表示
+        private enum ColumnIndex
+        {
+            ConstructionCode,           // ■工事番号
+            OrderNo,                    // ■連番
+            No,                         // 行番号
+            ConstructionName,           // 現場名
+            BillPrice,                  // 金額
+            ReadOnly,
+        }
+
+        // 取得するデータ項目
+        private enum ClickGetData
+        {
+            RequestNo = 0,
+            OrderNo,
+            OrderersDivision,
+            OrderersCode,
+            BillCreationDate,
+            BillTotalPrice,
+            BillPrice,
+            TaxPrice,
+            DetailString,
+            PersonCode,
+            PersonName,
+            DepartmentCode,
+        }
+
+        // 発注者区分
+        public int m_OrderersDivision = 0;
+
+        // 発注者コード
+        public int m_OrderersCode = 0;
+
+        public class MyFieldData
+        {
+            public int PersonCode { set; get; }
+            public int OrderersDivision { set; get; }
+            public int OrderersCode { set; get; }
+            public int RequestNo { set; get; }
+            public int OrderNo { set; get; }
+            public string ConstructionName { set; get; }
+            public string ConstructionName_Raw { set; get; }
+            public int DepartmentCode { set; get; }
+            public string BillCreationDate { set; get; }
+            public int BillPrice { set; get; }
+            public int TaxPrice { set; get; }
+            public int DepositAmount { set; get; }
+            public bool DeleteFlg { set; get; }
+            public bool ReadOnly { set; get; }
+        }
+
+        public List<MyFieldData> m_lstMyField = new List<MyFieldData>();
+
+        // 終了状態フラグ
+        private DialogResult m_EndButton = DialogResult.None;
+
+        // 終了ボタン押下
+        public DialogResult EndButton
+        {
+            get { return m_EndButton; }
+        }
+
+        // フォーム初期化
+        public FrmSelectRegField()
+        {
+            InitializeComponent();
+        }
+
+        // フォームロード
+        private void FrmRegField_Load(object sender, EventArgs e)
+        {
+            //フォームサイズ固定
+            this.MaximizedBounds = new Rectangle(this.Left, this.Top, this.Width, this.Height);
+
+            // 発注者名表示
+            DispOrdersName();
+
+            // 現場名表示
+            ItemListDisplay();
+        }
+
+        // 現場追加ボタン押下
+        private void btnAdd_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                // 一旦セルの値変更と行選択変更イベントを無効にする
+                dgv1.CellValueChanged -= dgv1_CellValueChanged;
+                dgv1.SelectionChanged -= dgv1_SelectionChanged;
+
+                FrmSelectRequest f = new FrmSelectRequest(FrmSelectRequest.OpenMode.AddFld);
+                f.m_OrderDiv = m_OrderersDivision;
+                f.m_OrderCode = m_OrderersCode;
+
+                f.FormClosed += new FormClosedEventHandler(NotifyEditFld_FormClosed);
+                f.ShowDialog(this);
+
+                // イベントハンドラ再登録
+                dgv1.CellValueChanged += dgv1_CellValueChanged;
+                dgv1.SelectionChanged += dgv1_SelectionChanged;
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        // 現場削除ボタン押下
+        private void btnDelete_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                if (dgv1.CurrentCell.RowIndex <= 1) return;
+
+                // 一旦セルの値変更と行選択変更イベントを無効にする
+                dgv1.CellValueChanged -= dgv1_CellValueChanged;
+                dgv1.SelectionChanged -= dgv1_SelectionChanged;
+
+                // 内部データを更新
+                foreach (MyFieldData MyData in m_lstMyField)
+                {
+                    if ((MyData.RequestNo == CommonMotions.cnvInt(dgv1.Rows[dgv1.CurrentCell.RowIndex].Cells[(int)ColumnIndex.ConstructionCode].Value)) &&
+                        (MyData.OrderNo == CommonMotions.cnvInt(dgv1.Rows[dgv1.CurrentCell.RowIndex].Cells[(int)ColumnIndex.OrderNo].Value)))
+                    {
+                        MyData.DeleteFlg = true;
+                    }
+                }
+
+                foreach (DataGridViewRow gridRow in dgv1.SelectedRows)
+                {
+                    // Gridから選択行を削除する
+                    dgv1.Rows.Remove(gridRow);
+                }
+
+                // 不明行を再計算して表示
+                CalcUnknownBillPrice();
+
+                // 行番号を再付番
+                for (int rowIndex = 2; rowIndex < dgv1.RowCount; rowIndex++)
+                {
+                    dgv1.Rows[rowIndex].Cells[(int)ColumnIndex.No].Value = rowIndex + 1;
+                }
+
+                // イベントハンドラ再登録
+                dgv1.CellValueChanged += dgv1_CellValueChanged;
+                dgv1.SelectionChanged += dgv1_SelectionChanged;
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        // 登録ボタン押下
+        private void btnAccept_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                // 結果をOKにして画面を閉じる
+                m_EndButton = DialogResult.OK;
+                this.Close();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        // 終了ボタン押下
+        private void btnEnd_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                m_EndButton = DialogResult.No;
+                this.Close();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        // 一覧選択行変更時処理
+        private void dgv1_SelectionChanged(object sender, EventArgs e)
+        {
+            try
+            {
+                if (dgv1.CurrentCell.RowIndex >= 2)
+                {
+                    btnDelete.Enabled = true;
+                    foreach (DataGridViewRow gridRow in dgv1.SelectedRows)
+                    {
+                        // 選択された行のReadOnlyカラム(非表示)を参照して、trueの場合は削除ボタンを無効、falseの場合は有効にする
+                        btnDelete.Enabled &= !((bool)gridRow.Cells[(int)ColumnIndex.ReadOnly].Value);
+                    }
+                }
+                else
+                {
+                    // 選択行が一つもない場合は、削除ボタンを無効にする
+                    btnDelete.Enabled = false;
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        // Gridセル値変更時処理
+        private void dgv1_CellValueChanged(object sender, DataGridViewCellEventArgs e)
+        {
+            try
+            {
+                // 行が追加されたときではなく、セルの内容が変更されているときだけ処理を実行する。また金額以外の変更は処理を抜ける。
+                if (e.RowIndex == dgv1.NewRowIndex || !dgv1.IsCurrentCellDirty || e.ColumnIndex != (int)ColumnIndex.BillPrice)
+                {
+                    return;
+                }
+
+                // 内部データを更新
+                foreach (MyFieldData FldData in m_lstMyField)
+                {
+                    if ((FldData.RequestNo == CommonMotions.cnvInt(dgv1.Rows[e.RowIndex].Cells[(int)ColumnIndex.ConstructionCode].Value)) &&
+                        (FldData.OrderNo == CommonMotions.cnvInt(dgv1.Rows[e.RowIndex].Cells[(int)ColumnIndex.OrderNo].Value)))
+                    {
+                        FldData.DepositAmount = CommonMotions.cnvInt(dgv1.Rows[e.RowIndex].Cells[(int)ColumnIndex.BillPrice].Value);
+                        break;
+                    }
+                }
+
+                // 不明行を再計算して表示
+                CalcUnknownBillPrice();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        // 発注者名表示
+        private void DispOrdersName()
+        {
+            IOMOrderers IoOm = new IOMOrderers();
+            List<OrderersMaster> lstOm = new List<OrderersMaster>();
+
+            try
+            {
+                // 一旦セルの値変更と行選択変更イベントを無効にする
+                dgv1.CellValueChanged -= dgv1_CellValueChanged;
+                dgv1.SelectionChanged -= dgv1_SelectionChanged;
+
+                string sSql = string.Format(" where OrderCotegory = {0} and OrderersCode = {1}", m_OrderersDivision, m_OrderersCode);
+                if (!IoOm.SelectAction(sSql, ref lstOm)) return;
+
+                string OrderName = "";
+                foreach (OrderersMaster OmInfo in lstOm)
+                {
+                    // 発注社名１△発注者名２
+                    if (OmInfo.CorporateStatusPoint == 0)
+                    {
+                        if (OmInfo.OrderersName2 == "")
+                        {
+                            OrderName = OmInfo.OrderersName1;
+                        }
+                        else
+                        {
+                            OrderName = OmInfo.OrderersName1 + "　" + OmInfo.OrderersName2;
+                        }
+                    }
+                    // 法人格名称△発注者名１△発注者名２
+                    else if (OmInfo.CorporateStatusPoint == 1)
+                    {
+                        if (OmInfo.OrderersName2 == "")
+                        {
+                            OrderName = OmInfo.CorporateStatusName + "　" + OmInfo.OrderersName1;
+                        }
+                        else
+                        {
+                            OrderName = OmInfo.CorporateStatusName + "　" + OmInfo.OrderersName1 + "　" + OmInfo.OrderersName2;
+                        }
+                    }
+                    // 発注者名１△法人格名称△発注者名２
+                    else
+                    {
+                        if (OmInfo.OrderersName2 == "")
+                        {
+                            OrderName = OmInfo.OrderersName1 + "　" + OmInfo.CorporateStatusName;
+                        }
+                        else
+                        {
+                            OrderName = OmInfo.OrderersName1 + "　" + OmInfo.CorporateStatusName + "　" + OmInfo.OrderersName2;
+                        }
+                    }
+                    if (OmInfo.OrderCotegory == 8)
+                    {
+                        OrderName += "様";
+                    }
+                }
+
+                tboxCompany.Text = OrderName;
+
+                dgv1.CellValueChanged += dgv1_CellValueChanged;
+                dgv1.SelectionChanged += dgv1_SelectionChanged;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                IoOm = null;
+            }
+        }
+
+        // 不明金額の再計算および表示
+        private void CalcUnknownBillPrice()
+        {
+            try
+            {
+                // 請求金額合計を算出
+                int UnknownPrice = CommonMotions.cnvInt(dgv1.Rows[0].Cells[(int)ColumnIndex.BillPrice].Value);
+                for (int rowIndex = 1; rowIndex < dgv1.RowCount; rowIndex++)
+                {
+                    UnknownPrice -= CommonMotions.cnvInt(dgv1.Rows[rowIndex].Cells[(int)ColumnIndex.BillPrice].Value);
+                }
+
+                // 不明行の金額欄に値をセット
+                dgv2.Rows[0].Cells[(int)ColumnIndex.BillPrice].Value = UnknownPrice.ToString("#,0");
+
+                foreach (MyFieldData MyData in m_lstMyField)
+                {
+                    if ((MyData.ConstructionName == "不明") &&
+                        (MyData.ConstructionName_Raw == ""))
+                    {
+                        MyData.DepositAmount = UnknownPrice;
+                    }
+
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        // 現場一覧表表示
+        private void ItemListDisplay()
+        {
+            try
+            {
+                // 一旦セルの値変更と行選択変更イベントを無効にする
+                dgv1.CellValueChanged -= dgv1_CellValueChanged;
+                dgv1.SelectionChanged -= dgv1_SelectionChanged;
+
+                // DataGridを一旦クリア
+                dgv1.Rows.Clear();
+                dgv2.Rows.Clear();
+
+                // 金額行のフォーマットを指定
+                dgv1.Columns[(int)ColumnIndex.BillPrice].DefaultCellStyle.Format = "#,0";
+                dgv2.Columns[(int)ColumnIndex.BillPrice].DefaultCellStyle.Format = "#,0";
+
+                // 入金金額合計、他担当割り当て済み金額を算出
+                int TotalPrice = 0;
+                int OtherParsonPrice = 0;
+                foreach(MyFieldData MyData in m_lstMyField)
+                {
+                    TotalPrice += MyData.DepositAmount;
+                    if ((MyData.PersonCode != CommonMotions.LoginUserData.PersonCode) &&
+                        (MyData.PersonCode != 0))
+                    {
+                        OtherParsonPrice += MyData.DepositAmount;
+                    }
+                }
+
+                // 請求書金額行を追加
+                dgv1.Rows.Add(0, 0, "", "入金金額", TotalPrice, true);
+                dgv1.Rows[dgv1.RowCount - 1].DefaultCellStyle.BackColor = Color.Yellow;
+                dgv1.Rows[dgv1.RowCount - 1].Resizable = DataGridViewTriState.False;
+
+                //　他担当の現場割当済行を追加
+                dgv1.Rows.Add(0, 0, "", "他担当の現場割当済", OtherParsonPrice, true);
+                dgv1.Rows[dgv1.RowCount - 1].DefaultCellStyle.BackColor = Color.Yellow;
+                dgv1.Rows[dgv1.RowCount - 1].Resizable = DataGridViewTriState.False;
+
+                int rowCount = 0;
+
+                foreach (MyFieldData MyData in m_lstMyField)
+                {
+                    if (MyData.PersonCode == CommonMotions.LoginUserData.PersonCode)
+                    {
+                        // 各現場の行を追加
+                        dgv1.Rows.Add(MyData.RequestNo, MyData.OrderNo, ++rowCount, MyData.ConstructionName, MyData.DepositAmount, MyData.ReadOnly);
+                        dgv1.Rows[dgv1.RowCount - 1].Cells[(int)ColumnIndex.BillPrice].ReadOnly = MyData.ReadOnly;
+                        dgv1.Rows[dgv1.RowCount - 1].Resizable = DataGridViewTriState.False;
+                    }
+                }
+
+                // 不明の行を追加
+                dgv2.Rows.Add(0, 0, "", "不明", 0);
+
+                // 不明行を再計算して表示
+                CalcUnknownBillPrice();
+
+                // イベントハンドラ再登録
+                dgv1.CellValueChanged += dgv1_CellValueChanged;
+                dgv1.SelectionChanged += dgv1_SelectionChanged;
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        // 現場登録ダイアログクローズ通知
+        private void NotifyEditFld_FormClosed(object sender, FormClosedEventArgs e)
+        {
+            FrmSelectRequest f = (FrmSelectRequest)sender;
+
+            try
+            {
+                // 一旦セルの値変更と行選択変更イベントを無効にする
+                dgv1.CellValueChanged -= dgv1_CellValueChanged;
+                dgv1.SelectionChanged -= dgv1_SelectionChanged;
+
+                if (f.m_lstAddFldData.Count() == 0) return;
+
+                // 現場追加あり
+                foreach(FrmSelectRequest.AddFldData AddInfo in f.m_lstAddFldData)
+                {
+                    bool isExist = false;
+                    foreach (MyFieldData FldData in m_lstMyField)
+                    {
+                        if ((FldData.RequestNo == AddInfo.RequestNo) &&
+                            (FldData.OrderNo == AddInfo.OrderNo) &&
+                            (FldData.DeleteFlg == false))
+                        {
+                            isExist = true;
+                            break;
+                        }
+                    }
+                    if (!isExist)
+                    {
+                        // 不明データを末尾にして挿入すること！
+                        int InsPos = m_lstMyField.Count;
+                        if ((m_lstMyField[m_lstMyField.Count - 1].ConstructionName == "不明") &&
+                            (m_lstMyField[m_lstMyField.Count - 1].ConstructionName_Raw == ""))
+                        {
+                            InsPos = m_lstMyField.Count - 1;
+                        }
+
+                        m_lstMyField.Insert(InsPos, new MyFieldData()
+                        {
+                            PersonCode = CommonMotions.LoginUserData.PersonCode,
+                            OrderersDivision = AddInfo.OrderersDivision,
+                            OrderersCode = AddInfo.OrderersCode,
+                            RequestNo = AddInfo.RequestNo,
+                            OrderNo = AddInfo.OrderNo,
+                            ConstructionName = AddInfo.FieldName,
+                            ConstructionName_Raw = AddInfo.FieldName,
+                            DepartmentCode = AddInfo.DepartmentCode,
+                            BillCreationDate = AddInfo.BillCreationDate,
+                            BillPrice = AddInfo.BillPrice,
+                            TaxPrice = AddInfo.TaxPrice,
+                            DepositAmount = AddInfo.BillTotalPrice,
+                            DeleteFlg = false,
+                            ReadOnly = false,
+                        });
+                        // 各現場の行を追加
+                        dgv1.Rows.Add(AddInfo.RequestNo, AddInfo.OrderNo, dgv1.RowCount - 1, AddInfo.FieldName, AddInfo.BillTotalPrice, false);
+                        dgv1.Rows[dgv1.RowCount - 1].Cells[(int)ColumnIndex.BillPrice].ReadOnly = false;
+                        dgv1.Rows[dgv1.RowCount - 1].Resizable = DataGridViewTriState.False;
+                    }
+                }
+
+                // 不明行を再計算して表示
+                CalcUnknownBillPrice();
+
+                // イベントハンドラ再登録
+                dgv1.CellValueChanged += dgv1_CellValueChanged;
+                dgv1.SelectionChanged += dgv1_SelectionChanged;
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+    }
+}
